#!/bin/bash

##############
# Ausfuehrung #
##############
# ./mcdopes

#########################
# Einstellungen         #
#########################
echo "~~ McDope's LCD ~~"
echo "~~ - Setting up G15Composer..."
killall -9 g15composer
nohup /usr/local/bin/g15composer /tmp/g15disp &
sleep 3
STREAM=/tmp/g15disp
echo "~~ - ...done!"

####################
#VARs zerpfluecken #
####################
output_args_one_per_arg_cpu()
{
	USR=$1
	#USR=`echo $1 | cut -c 0-1`
	SYS=$2
	IDL=$3
	ALL=$1+$2
	#ALL=`echo $ALL | cut -c 0-1`
}

output_args_one_per_arg_load()
{
	min1=$1
	min5=$2
	min15=$3
}

output_args_one_per_arg_net()
{
	bin=$1
	bout=$2
	
	# in KB umrechnen
	bytesin=$[$bin / 1024]
	bytesout=$[$bout / 1024]
}

##############################
# Ausgabe ans LCD (Schleife) #
##############################
ZZZ=1
echo 'LB 2' >> $STREAM
echo 'LC 2' >> $STREAM
while :  
 do
    echo "~~ Generating LCD Output [Run $ZZZ]..."
	
	# turn output buffering on
	echo 'MC 1' >> $STREAM

    # build date
    DATACLOCKT=`date +%T`
    DATACLOCKH=`date +%H`
    DATACLOCKMIN=`date +%M`
    DATACLOCKS=`date +%S`
    DATACLOCKD=`date +%d`
    DATACLOCKM=`date +%b`
    DATACLOCKMN=`date +%m`
    DATACLOCKY=`date +%Y`

	# get and process cpu load 
    #CPU=`./cpustat | awk '{print $1 "\t" $2 "\t" $3 }'`
    #output_args_one_per_arg_cpu $CPU
	USR=`mpstat | grep all | awk '{print $3}' | sed 's/,/./'`
	SYS=`mpstat | grep all | awk '{print $4}' | sed 's/,/./'`

    # get and process load average
	LOAD=`awk '{print $1 "\t" $2 "\t" $3 }' /proc/loadavg`
    output_args_one_per_arg_load $LOAD
      
    # read temperatures
	SPEED=`sensors | grep temp1 | cut -c 15-16`
    TEMP=`sensors | grep temp2 | cut -c 13-14` 
    #BATT=`acpi -b | cut -c 26-30`

    # eth0 interface traffic
	NETWORK=`./lifstat -i eth0 1 1 -n | awk '{print $2 "\t" $5 }'`
    output_args_one_per_arg_net $NETWORK
	
	# get mem usage and total mem
	MEMUSED=`free | grep "/+ buffers" | awk '{print $3}'`
	MEMTOTAL=`free | grep "Mem:" | awk '{print $2}'`

    # clean screen
	echo 'PC 0' >> $STREAM


    #fake bar containers
    echo 'DL 1 7 77 7 1' >> $STREAM
    echo 'DL 1 19 77 19 1' >> $STREAM
    echo 'DL 0 8 0 12 1' >> $STREAM
    echo 'DL 78 8 78 12 1' >> $STREAM
    echo 'DL 0 14 0 18 1' >> $STREAM
    echo 'DL 78 14 78 18 1' >> $STREAM
    echo 'DL 82 7 158 7 1' >> $STREAM
    echo 'DL 82 19 158 19 1' >> $STREAM
    echo 'DL 0 8 0 12 1' >> $STREAM
    echo 'DL 78 8 78 12 1' >> $STREAM
    echo 'DL 0 14 0 18 1' >> $STREAM
    echo 'DL 78 14 78 18 1' >> $STREAM
    echo 'DL 1 13 77 13 1' >> $STREAM
    echo 'DL 82 13 158 13 1' >> $STREAM
    echo 'DL 81 8 81 12 1' >> $STREAM
    echo 'DL 159 8 159 12 1' >> $STREAM
    echo 'DL 81 14 81 18 1' >> $STREAM
    echo 'DL 159 14 159 18 1' >> $STREAM

    #bottom boxes, top lines
    echo 'DL 1 21 37 21 1' >> $STREAM
    echo 'DL 41 21 77 21 1' >> $STREAM
    echo 'DL 82 21 118 21 1' >> $STREAM
    echo 'DL 122 21 158 21 1' >> $STREAM

    #bottom leftleft box, left & right line
    echo 'DL 0 22 0 44 1' >> $STREAM
    echo 'DL 38 22 38 44 1' >> $STREAM

    #bottom leftmiddle box, left & right line
    echo 'DL 40 22 40 44 1' >> $STREAM
    echo 'DL 78 22 78 44 1' >> $STREAM

    #bottom middleright box, left & right line
    echo 'DL 81 22 81 44 1' >> $STREAM
    echo 'DL 119 22 119 44 1' >> $STREAM

    #bottom rightright box, left & right line
    echo 'DL 121 22 121 44 1' >> $STREAM
    echo 'DL 159 22 159 44 1' >> $STREAM

    #text backgrounds
    echo 'PF 1 8 18 18 1' >> $STREAM
    echo 'PF 82 8 99 18 1' >> $STREAM

    #text labels
    #  -- cpu [c]
    echo 'DL 1 9 1 11 0' >> $STREAM
    echo 'DL 2 8 5 8 0' >> $STREAM
    echo 'DL 2 12 5 12 0' >> $STREAM
    #  -- cpu [p]
    echo 'DL 7 8 7 12 0' >> $STREAM
    echo 'DL 8 8 10 8 0' >> $STREAM
    echo 'DL 8 10 10 10 0' >> $STREAM
    echo 'PS 11 9 0' >> $STREAM
    #  -- cpu [u]
    echo 'DL 13 8 13 11 0' >> $STREAM
    echo 'DL 17 8 17 11 0' >> $STREAM
    echo 'DL 14 12 16 12 0' >> $STREAM
    #  -- mem [m]
    echo 'DL 1 14 1 18 0' >> $STREAM
    echo 'DL 5 14 5 18 0' >> $STREAM
    echo 'PS 2 15 0' >> $STREAM
    echo 'PS 3 16 0' >> $STREAM
    echo 'PS 4 15 0' >> $STREAM
    #  -- mem [e]
    echo 'DL 7 14 7 18 0' >> $STREAM
    echo 'DL 8 14 11 14 0' >> $STREAM
    echo 'DL 8 18 11 18 0' >> $STREAM
    echo 'DL 8 16 9 16 0' >> $STREAM
    #  -- mem [m]
    echo 'DL 13 14 13 18 0' >> $STREAM
    echo 'DL 17 14 17 18 0' >> $STREAM
    echo 'PS 14 15 0' >> $STREAM
    echo 'PS 15 16 0' >> $STREAM
    echo 'PS 16 15 0' >> $STREAM
    #  -- in [i]
    echo 'DL 82 8 82 12 0' >> $STREAM
    #  -- in [n]
    echo 'DL 84 8 84 12 0' >> $STREAM
    echo 'PS 85 9 0' >> $STREAM
    echo 'PS 86 10 0' >> $STREAM
    echo 'DL 87 8 87 12 0' >> $STREAM
    # -- out [o]
    echo 'DL 82 15 82 17 0' >> $STREAM
    echo 'DL 85 15 85 17 0' >> $STREAM
    echo 'DL 83 14 84 14 0' >> $STREAM
    echo 'DL 83 18 84 18 0' >> $STREAM
    # -- out [u]
    echo 'DL 87 14 87 17 0' >> $STREAM
    echo 'DL 90 14 90 17 0' >> $STREAM
    echo 'DL 88 18 89 18 0' >> $STREAM
    # -- out [t]
    echo 'DL 92 14 94 14 0' >> $STREAM
    echo 'DL 93 15 93 18 0' >> $STREAM
    #text labels end

    #cpu load bar (based on user+sys load)
    for (( i = 9; i < 12; i++ ))
    do
		HLP=`echo -e "20+(76-20)*($USR+$SYS)/100\n" | bc`
		echo 'DL 20 '$i' '$[20+(76-20)*$HLP/100]' '$i' 1' >> $STREAM
    done
	
	#mem usage bar
	for (( i = 15; i < 18; i++ ))
	do
	   echo 'DL 20 '$i' '$[20+(76-20)*$MEMUSED/$MEMTOTAL]' '$i' 1' >> $STREAM
	done

    #net traffic bars
    max_up=122880
	max_down=1782579
	
	# -- in/down traffic
	for (( i = 9; i < 12; i++ )) 
	do
        echo 'DL 101 '$i' '$[101+(157-101)*$bin/$max_down]' '$i' 1' >> $STREAM
	done

	# -- out/up traffic
	for (( i = 15; i < 18; i++ ))
	do
		echo 'DL 101 '$i' '$[101+(157-101)*$bout/$max_up]' '$i' 1' >> $STREAM
	done

    echo 'TM  "'$DATACLOCKT'             '$DATACLOCKD'.'$DATACLOCKM'.'$DATACLOCKY'"' >> $STREAM
 
 
    # Ausgabe der CPU Informationen #
    #echo 'PF 1 22 37 27 1' >> $STREAM
    echo 'TO 2 23 0 0 "CPU STATS"' > $STREAM    
    echo 'DL 1 29 37 29 1' >> $STREAM
    echo 'TO 2 31 0 0 "usr:"' > $STREAM    
    echo 'TO 2 37 0 0 "sys:"' > $STREAM
    echo 'TO 18 31 0 0 "'$USR'%"' > $STREAM
    echo 'TO 18 37 0 0 "'$SYS'%"' > $STREAM

    # Ausgabe der LAN Informationen # 
    echo 'DL 41 29 77 29 1' >> $STREAM
    echo 'TO 45 23 0 0 "LAN I/O"' > $STREAM    
    echo 'TO 42 31 0 0 "<-"' > $STREAM
    echo 'TO 42 37 0 0 "->"' > $STREAM
    echo 'TO 50 31 0 0 "'$bytesin'kbs"' > $STREAM
    echo 'TO 50 37 0 0 "'$bytesout'kbs"' > $STREAM  

    # Ausgabe Avg. Systemload
    echo 'TO 83 23 0 0 "AVG. LOAD"' > $STREAM
    echo 'DL 82 29 118 29 1' >> $STREAM
    echo 'TO 83 31 0 0 " 5m:"' > $STREAM
    echo 'TO 83 37 0 0 "15m:"' > $STREAM
    echo 'TO 99 31 0 0 "'$min5'"' > $STREAM
    echo 'TO 99 37 0 0 "'$min15'"' > $STREAM

    # Ausgabe Sys Temps # 
    echo 'TO 123 23 0 0 "SYS TEMPS"' > $STREAM
    echo 'DL 122 29 158 29 1' >> $STREAM
    echo 'TO 123 31 0 0 "sys:"' > $STREAM
    echo 'TO 123 37 0 0 "cpu:"' > $STREAM
    echo 'TO 140 31 0 0 "'$SPEED'C"' > $STREAM
    echo 'TO 140 37 0 0 "'$TEMP'C"'> $STREAM

    # turn output buffering off
	echo 'MC 0' >> $STREAM

	echo "~~ ...done!"
	ZZZ=$[$ZZZ+1]
done;

exit 0

